import { __decorate, __metadata, __param, __read, __extends, __awaiter, __generator, __assign, __spread } from 'tslib';
import { ɵɵdefineInjectable, Injectable, EventEmitter, Input, Output, Component, forwardRef, NgModule, InjectionToken, Optional, Inject, ɵɵinject, ViewChild, ElementRef, ViewChildren, QueryList, Renderer2, HostListener, Directive, Pipe, ChangeDetectionStrategy } from '@angular/core';
import { NG_VALUE_ACCESSOR, ReactiveFormsModule, FormsModule } from '@angular/forms';
import { assoc, insert, remove, contains, pipe, when, always, isNil, repeat, reverse, range, update, is, sortBy } from 'ramda';
import { CommonModule, DOCUMENT, DatePipe } from '@angular/common';
import { ClrCheckboxModule, ClrDatepickerModule, ClrIconModule, ClrDropdownModule, ClrTooltipModule, ClrSelectModule, ClrRadioModule, ClrInputModule, ClrPasswordModule, ClrTextareaModule } from '@clr/angular';
import { parse as parse$1, format, setHours, getHours, setMinutes, getMinutes } from 'date-fns/esm/fp';
import { BrowserModule } from '@angular/platform-browser';
import { OnChange } from 'property-watch-decorator';
import { cleanupTypeaheadValue, HlcTypeaheadDirectiveModule } from '@ng-holistic/typeahead';
import { BehaviorSubject } from 'rxjs';
import { withLatestFrom } from 'rxjs/operators';

var DictMapperService = /** @class */ (function () {
    function DictMapperService() {
    }
    DictMapperService.prototype.getKey = function (item) {
        return item['key'];
    };
    DictMapperService.prototype.getLabel = function (item) {
        return item['label'];
    };
    DictMapperService.ɵprov = ɵɵdefineInjectable({ factory: function DictMapperService_Factory() { return new DictMapperService(); }, token: DictMapperService, providedIn: "root" });
    DictMapperService = __decorate([
        Injectable({ providedIn: 'root' })
    ], DictMapperService);
    return DictMapperService;
}());
var DictMapperSetterService = /** @class */ (function () {
    function DictMapperSetterService() {
    }
    DictMapperSetterService.prototype.setKey = function (item, key) {
        // item['key'] = key;
        return assoc('key', key, item);
    };
    DictMapperSetterService.prototype.setLabel = function (item, label) {
        // item['label'] = label;
        // return item;
        return assoc('label', label, item);
    };
    DictMapperSetterService.ɵprov = ɵɵdefineInjectable({ factory: function DictMapperSetterService_Factory() { return new DictMapperSetterService(); }, token: DictMapperSetterService, providedIn: "root" });
    DictMapperSetterService = __decorate([
        Injectable({ providedIn: 'root' })
    ], DictMapperSetterService);
    return DictMapperSetterService;
}());

var HlcClrCheckboxesComponent = /** @class */ (function () {
    function HlcClrCheckboxesComponent(dictMapper) {
        var _this = this;
        this.dictMapper = dictMapper;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        this.trackBy = function (_, obj) {
            return _this.mapKey(obj);
        };
    }
    HlcClrCheckboxesComponent_1 = HlcClrCheckboxesComponent;
    HlcClrCheckboxesComponent.prototype.ngOnInit = function () { };
    HlcClrCheckboxesComponent.prototype.onChange = function (item) {
        var key = this.mapKey(item);
        var index = (this.value || []).indexOf(key);
        if (!this.value) {
            this.value = [];
        }
        if (index === -1) {
            this.value = insert(0, key, this.value);
        }
        else {
            this.value = remove(index, 1, this.value);
        }
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    HlcClrCheckboxesComponent.prototype.isChecked = function (item) {
        var itemKey = this.mapKey(item);
        return this.value && contains(itemKey, this.value);
    };
    HlcClrCheckboxesComponent.prototype.mapKey = function (obj) {
        return this.dictMapper.getKey(obj);
    };
    HlcClrCheckboxesComponent.prototype.mapLabel = function (obj) {
        return this.dictMapper.getLabel(obj);
    };
    //
    HlcClrCheckboxesComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrCheckboxesComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrCheckboxesComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrCheckboxesComponent_1;
    HlcClrCheckboxesComponent.ctorParameters = function () { return [
        { type: DictMapperService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], HlcClrCheckboxesComponent.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrCheckboxesComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrCheckboxesComponent.prototype, "readonly", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrCheckboxesComponent.prototype, "valueChange", void 0);
    HlcClrCheckboxesComponent = HlcClrCheckboxesComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-checkboxes',
            template: "<clr-checkbox-wrapper *ngFor=\"let item of items; trackBy: trackBy; let index = index\">\r\n    <input\r\n        type=\"checkbox\"\r\n        clrCheckbox\r\n        [checked]=\"isChecked(item)\"\r\n        [value]=\"mapKey(item)\"\r\n        (change)=\"onChange(item)\"\r\n    />\r\n    <label>{{ mapLabel(item) }}</label>\r\n</clr-checkbox-wrapper>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrCheckboxesComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [DictMapperService])
    ], HlcClrCheckboxesComponent);
    return HlcClrCheckboxesComponent;
}());

var HlcClrCheckboxesModule = /** @class */ (function () {
    function HlcClrCheckboxesModule() {
    }
    HlcClrCheckboxesModule = __decorate([
        NgModule({
            imports: [CommonModule, ClrCheckboxModule],
            declarations: [HlcClrCheckboxesComponent],
            exports: [HlcClrCheckboxesComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrCheckboxesModule);
    return HlcClrCheckboxesModule;
}());

var DATE_CONVERT_CONFIG = new InjectionToken('DATE_CONVERT_CONFIG');
var parse = function (format) { return function (str) {
    if (!str) {
        return undefined;
    }
    return parse$1(new Date(), format, str);
}; };
var ɵ0 = parse;
var translateDateStr = function (parseStr, formatStr, str) {
    if (!str) {
        return undefined;
    }
    return pipe(parse(parseStr), function (x) { return x && format(formatStr)(x); })(str);
};
var ɵ1 = translateDateStr;
/**
 * Convert dates from controls formatted values to domain formatted strings
 * Input events value -> format to Date -> parse Date to domain formatted string
 */
var DateConvertService = /** @class */ (function () {
    function DateConvertService(config) {
        this.config = config;
    }
    /**
     * Convert control's way formatted date string to date
     */
    DateConvertService.prototype.parseControlDate = function (controlValue) {
        return parse(this.domainFormatStr)(controlValue);
    };
    /**
     * Format date to string in control format
     */
    DateConvertService.prototype.formatToControlsStr = function (date) {
        if (!date) {
            return undefined;
        }
        return format(this.controlsFormatStr, date);
    };
    /**
     * Convert domain's way formatted date string to date
     */
    DateConvertService.prototype.parseDomainDate = function (domainValue) {
        return parse(this.domainFormatStr)(domainValue);
    };
    /**
     * Format date to string in domain format
     */
    DateConvertService.prototype.formatToDomainStr = function (date) {
        if (!date) {
            return undefined;
        }
        return format(this.domainFormatStr, date);
    };
    /**
     * Converts control date string to domain string
     */
    DateConvertService.prototype.convert = function (controlValue) {
        return translateDateStr(this.controlsFormatStr, this.domainFormatStr, controlValue);
    };
    /**
     * Converts domain string to control date string
     */
    DateConvertService.prototype.format = function (str) {
        return translateDateStr(this.domainFormatStr, this.controlsFormatStr, str);
    };
    Object.defineProperty(DateConvertService.prototype, "domainFormatStr", {
        get: function () {
            if (this.config && this.config.domainFormat) {
                return this.config.domainFormat;
            }
            return 'yyyy-MM-dd\'T\'HH:mm:ss';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateConvertService.prototype, "controlsFormatStr", {
        get: function () {
            if (this.config && this.config.controlsFormat) {
                return this.config.controlsFormat;
            }
            // TODO: retrieve from ng locale
            return 'MM\/dd\/yyyy';
        },
        enumerable: true,
        configurable: true
    });
    DateConvertService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DATE_CONVERT_CONFIG,] }] }
    ]; };
    DateConvertService.ɵprov = ɵɵdefineInjectable({ factory: function DateConvertService_Factory() { return new DateConvertService(ɵɵinject(DATE_CONVERT_CONFIG, 8)); }, token: DateConvertService, providedIn: "root" });
    DateConvertService = __decorate([
        Injectable({ providedIn: 'root' }),
        __param(0, Optional()),
        __param(0, Inject(DATE_CONVERT_CONFIG)),
        __metadata("design:paramtypes", [Object])
    ], DateConvertService);
    return DateConvertService;
}());

var DATE_CONFIG = new InjectionToken('DATE_CONFIG');

var HlcClrDateComponent = /** @class */ (function () {
    function HlcClrDateComponent(dateConvertService, dateConfig) {
        var _this = this;
        this.dateConvertService = dateConvertService;
        this.dateConfig = dateConfig;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        this.formatToDomainStr = function (date) { return _this.dateConvertService.formatToDomainStr(date); };
    }
    HlcClrDateComponent_1 = HlcClrDateComponent;
    Object.defineProperty(HlcClrDateComponent.prototype, "date", {
        get: function () {
            return this.value ? this.dateConvertService.parseDomainDate(this.value) : undefined;
        },
        set: function (val) {
            // control formatted val -> domain date
            this.value = !val
                ? null
                : pipe(
                // if perviouse value not empty take hours + minutes from there
                when(always(this.value), pipe(setHours(getHours(this.value)), setMinutes(getMinutes(this.value)))), this.formatToDomainStr)(val);
            this.onChange();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrDateComponent.prototype, "placeholder", {
        get: function () {
            return this.dateConfig && this.dateConfig.placeholder;
        },
        enumerable: true,
        configurable: true
    });
    HlcClrDateComponent.prototype.ngOnInit = function () { };
    HlcClrDateComponent.prototype.onReset = function () {
        this.value = undefined;
        this.onChange();
    };
    HlcClrDateComponent.prototype.onChange = function () {
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    //
    HlcClrDateComponent.prototype.writeValue = function (obj) {
        this.value = obj;
        if (!this.value) {
            this.resetValue();
        }
    };
    HlcClrDateComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrDateComponent.prototype.registerOnTouched = function (_) { };
    //
    HlcClrDateComponent.prototype.resetValue = function () {
        if (this.input) {
            this.input.nativeElement.value = '';
        }
    };
    var HlcClrDateComponent_1;
    HlcClrDateComponent.ctorParameters = function () { return [
        { type: DateConvertService },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DATE_CONFIG,] }] }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrDateComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrDateComponent.prototype, "format", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrDateComponent.prototype, "readonly", void 0);
    __decorate([
        ViewChild('input', { static: false }),
        __metadata("design:type", ElementRef)
    ], HlcClrDateComponent.prototype, "input", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrDateComponent.prototype, "valueChange", void 0);
    HlcClrDateComponent = HlcClrDateComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-date',
            template: "<input\r\n    clrDate\r\n    [readonly]=\"readonly\"\r\n    [placeholder]=\"placeholder\"\r\n    #input\r\n    type=\"date\"\r\n    [(clrDate)]=\"date\">\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrDateComponent_1; }),
                    multi: true
                }
            ],
            styles: [":host ::ng-deep readonly .datepicker-trigger-icon{display:none}:host ::ng-deep .clr-form-control{margin-top:0}"]
        }),
        __param(1, Optional()), __param(1, Inject(DATE_CONFIG)),
        __metadata("design:paramtypes", [DateConvertService, Object])
    ], HlcClrDateComponent);
    return HlcClrDateComponent;
}());

/**
 * Converts domain `range` values to component ones.
 * For example domain range type could be in following formats `[x,y]` or `{from: x, to: y}}
 * We need universal way to convert these values to / from - component / domain
 * By default used `{from, to}` format
 */
var RangeMapperService = /** @class */ (function () {
    function RangeMapperService() {
    }
    RangeMapperService.prototype.getRange = function (item) {
        return [item['from'], item['to']];
    };
    RangeMapperService.prototype.setRange = function (val) {
        return { from: val[0], to: val[1] };
    };
    RangeMapperService.ɵprov = ɵɵdefineInjectable({ factory: function RangeMapperService_Factory() { return new RangeMapperService(); }, token: RangeMapperService, providedIn: "root" });
    RangeMapperService = __decorate([
        Injectable({ providedIn: 'root' })
    ], RangeMapperService);
    return RangeMapperService;
}());

var HlcClrDateRangeComponent = /** @class */ (function () {
    function HlcClrDateRangeComponent(rangeMapperService) {
        this.rangeMapperService = rangeMapperService;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
    }
    HlcClrDateRangeComponent_1 = HlcClrDateRangeComponent;
    HlcClrDateRangeComponent.prototype.ngOnInit = function () { };
    Object.defineProperty(HlcClrDateRangeComponent.prototype, "dateFrom", {
        get: function () {
            return this.value && this.rangeMapperService.getRange(this.value)[0];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrDateRangeComponent.prototype, "dateTo", {
        get: function () {
            return this.value && this.rangeMapperService.getRange(this.value)[1];
        },
        enumerable: true,
        configurable: true
    });
    HlcClrDateRangeComponent.prototype.onDateFromChange = function (val) {
        this.value = this.rangeMapperService.setRange([val, this.dateTo]);
        this.onChange();
    };
    HlcClrDateRangeComponent.prototype.onDateToChange = function (val) {
        this.value = this.rangeMapperService.setRange([this.dateFrom, val]);
        this.onChange();
    };
    HlcClrDateRangeComponent.prototype.onChange = function () {
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    //
    HlcClrDateRangeComponent.prototype.writeValue = function (obj) {
        this.value = obj;
        if (!this.value && this.dateComponents) {
            this.dateComponents.forEach(function (x) { return x.resetValue(); });
        }
    };
    HlcClrDateRangeComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrDateRangeComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrDateRangeComponent_1;
    HlcClrDateRangeComponent.ctorParameters = function () { return [
        { type: RangeMapperService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrDateRangeComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrDateRangeComponent.prototype, "format", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrDateRangeComponent.prototype, "readonly", void 0);
    __decorate([
        ViewChildren(HlcClrDateComponent),
        __metadata("design:type", QueryList)
    ], HlcClrDateRangeComponent.prototype, "dateComponents", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrDateRangeComponent.prototype, "valueChange", void 0);
    HlcClrDateRangeComponent = HlcClrDateRangeComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-date-range',
            template: "<hlc-clr-date\r\n    class=\"date-component date-short-component\"\r\n    [value]=\"dateFrom\"\r\n    (valueChange)=\"onDateFromChange($event)\"\r\n    [format]=\"format\"\r\n    [readonly]=\"readonly\"\r\n>\r\n</hlc-clr-date>\r\n-\r\n<hlc-clr-date\r\n    class=\"date-component date-short-component\"\r\n    [value]=\"dateTo\"\r\n    (valueChange)=\"onDateToChange($event)\"\r\n    [format]=\"format\"\r\n    [readonly]=\"readonly\"\r\n>\r\n</hlc-clr-date>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrDateRangeComponent_1; }),
                    multi: true
                }
            ],
            styles: [".date-component{display:inline-table}::ng-deep .date-short-component .date-input{width:120px}"]
        }),
        __metadata("design:paramtypes", [RangeMapperService])
    ], HlcClrDateRangeComponent);
    return HlcClrDateRangeComponent;
}());

var HlcClrDateModule = /** @class */ (function () {
    function HlcClrDateModule() {
    }
    HlcClrDateModule = __decorate([
        NgModule({
            imports: [CommonModule, ClrDatepickerModule, ClrIconModule],
            declarations: [HlcClrDateComponent],
            exports: [HlcClrDateComponent],
            providers: [DateConvertService],
            entryComponents: [HlcClrDateComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrDateModule);
    return HlcClrDateModule;
}());

var HlcClrDateRangeModule = /** @class */ (function () {
    function HlcClrDateRangeModule() {
    }
    HlcClrDateRangeModule = __decorate([
        NgModule({
            imports: [CommonModule, HlcClrDateModule],
            declarations: [HlcClrDateRangeComponent],
            exports: [HlcClrDateRangeComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrDateRangeModule);
    return HlcClrDateRangeModule;
}());

var HlcClrDateTimeComponent = /** @class */ (function () {
    function HlcClrDateTimeComponent(dateConvertService, dateConfig) {
        var _this = this;
        this.dateConvertService = dateConvertService;
        this.dateConfig = dateConfig;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        //
        this.formatToDomainStr = function (date) { return _this.dateConvertService.formatToDomainStr(date); };
        this.hours = Array.from({ length: 24 }, function (_, i) { return ({
            key: i,
            label: i.toString().padStart(2, '0')
        }); });
        this.minutes = Array.from({ length: 60 }, function (_, i) { return ({
            key: i,
            label: i.toString().padStart(2, '0')
        }); });
    }
    HlcClrDateTimeComponent_1 = HlcClrDateTimeComponent;
    Object.defineProperty(HlcClrDateTimeComponent.prototype, "dictMapper", {
        get: function () {
            return new DictMapperService();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrDateTimeComponent.prototype, "date", {
        get: function () {
            return this.dateConvertService.parseDomainDate(this.value);
        },
        set: function (val) {
            // control formatted val -> domain date
            this.value = !val
                ? null
                : pipe(
                // if pervious value not empty take hours + minutes from there
                when(always(this.value), pipe(setHours(getHours(this.value)), setMinutes(getMinutes(this.value)))), this.formatToDomainStr)(val);
            this.onChange();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrDateTimeComponent.prototype, "placeholder", {
        get: function () {
            return this.dateConfig && this.dateConfig.placeholder;
        },
        enumerable: true,
        configurable: true
    });
    HlcClrDateTimeComponent.prototype.ngOnInit = function () { };
    HlcClrDateTimeComponent.prototype.onChange = function () {
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    //
    HlcClrDateTimeComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrDateTimeComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrDateTimeComponent.prototype.registerOnTouched = function (_) { };
    Object.defineProperty(HlcClrDateTimeComponent.prototype, "hour", {
        //
        get: function () {
            return this.date ? getHours(this.date) : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrDateTimeComponent.prototype, "minute", {
        get: function () {
            return this.date ? getMinutes(this.date) : undefined;
        },
        enumerable: true,
        configurable: true
    });
    HlcClrDateTimeComponent.prototype.onHourChange = function (hour) {
        this.value = pipe(setHours(hour), 
        // reset minutes if value still not defined
        when(always(!this.value), setMinutes(0)), this.formatToDomainStr)(this.date || new Date());
        this.onChange();
    };
    HlcClrDateTimeComponent.prototype.onMinuteChange = function (min) {
        this.value = pipe(setMinutes(min), 
        // reset hours if value still not defined
        when(always(!this.value), setHours(0)), this.formatToDomainStr)(this.date || new Date());
        this.onChange();
    };
    var HlcClrDateTimeComponent_1;
    HlcClrDateTimeComponent.ctorParameters = function () { return [
        { type: DateConvertService },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DATE_CONFIG,] }] }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrDateTimeComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrDateTimeComponent.prototype, "format", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrDateTimeComponent.prototype, "readonly", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrDateTimeComponent.prototype, "valueChange", void 0);
    HlcClrDateTimeComponent = HlcClrDateTimeComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-date-time',
            template: "<input [readonly]=\"readonly\" [placeholder]=\"placeholder\" #input type=\"date\" [(clrDate)]=\"date\" />\r\n\r\n<div class=\"time-container\">\r\n    <hlc-clr-select\r\n        [disallowEmpty]=\"true\"\r\n        [items]=\"hours\"\r\n        [value]=\"hour\"\r\n        [dictMapper]=\"dictMapper\"\r\n        (valueChange)=\"onHourChange($event)\"\r\n    ></hlc-clr-select>\r\n\r\n    <hlc-clr-select\r\n        [disallowEmpty]=\"true\"\r\n        [items]=\"minutes\"\r\n        [value]=\"minute\"\r\n        [dictMapper]=\"dictMapper\"\r\n        (valueChange)=\"onMinuteChange($event)\"\r\n    ></hlc-clr-select>\r\n</div>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrDateTimeComponent_1; }),
                    multi: true
                }
            ],
            styles: [":host{display:flex}:host ::ng-deep .clr-form-control{margin-top:0}:host ::ng-deep readonly .datepicker-trigger-icon{display:none}.remove__icon{margin-top:10px;margin-left:5px}.hlc-clr-input{width:120px}"]
        }),
        __param(1, Optional()), __param(1, Inject(DATE_CONFIG)),
        __metadata("design:paramtypes", [DateConvertService, Object])
    ], HlcClrDateTimeComponent);
    return HlcClrDateTimeComponent;
}());

var HlcClrSelectComponent = /** @class */ (function () {
    function HlcClrSelectComponent(dictMapperService) {
        var _this = this;
        this.dictMapperService = dictMapperService;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        this.trackBy = function (_, obj) {
            return _this.mapKey(obj);
        };
    }
    HlcClrSelectComponent_1 = HlcClrSelectComponent;
    Object.defineProperty(HlcClrSelectComponent.prototype, "items", {
        get: function () {
            return this._items;
        },
        set: function (items) {
            this._items = items;
            if (!isNil(this._tmpValue)) {
                this.setValue(this._tmpValue);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrSelectComponent.prototype, "value", {
        get: function () {
            return this._tmpValue || this._value;
        },
        set: function (val) {
            this.setValue(val);
        },
        enumerable: true,
        configurable: true
    });
    HlcClrSelectComponent.prototype.ngOnInit = function () { };
    HlcClrSelectComponent.prototype.onChange = function (val) {
        /**
         * Option change event always give string as an option value, event if value actually was other object type,
         * this is wrong obviously when key is number.
         * So use selectedIndex instead of val.target.value
         */
        var selectedIndex = val.target.selectedIndex - (this.disallowEmpty ? 0 : 1);
        this.value = selectedIndex === -1 ? null : this.mapKey((this.items || [])[selectedIndex]);
        this.propagateChange(this.value);
        this.valueChange.emit(this.value);
    };
    HlcClrSelectComponent.prototype.mapKey = function (obj) {
        return (this.dictMapper || this.dictMapperService).getKey(obj);
    };
    HlcClrSelectComponent.prototype.mapLabel = function (obj) {
        return (this.dictMapper || this.dictMapperService).getLabel(obj);
    };
    HlcClrSelectComponent.prototype.setValue = function (val) {
        var _this = this;
        if (isNil(val)) {
            this._tmpValue = null;
            this._value = null;
            return;
        }
        var hasItem = (this.items || []).some(function (i) { return _this.mapKey(i) === val; });
        if (hasItem) {
            this._tmpValue = null;
            this._value = val;
        }
        else {
            this._tmpValue = val;
            this._value = null;
        }
    };
    //
    HlcClrSelectComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrSelectComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrSelectComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrSelectComponent_1;
    HlcClrSelectComponent.ctorParameters = function () { return [
        { type: DictMapperService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], HlcClrSelectComponent.prototype, "items", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], HlcClrSelectComponent.prototype, "value", null);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrSelectComponent.prototype, "naked", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrSelectComponent.prototype, "disallowEmpty", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrSelectComponent.prototype, "readonly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrSelectComponent.prototype, "dictMapper", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrSelectComponent.prototype, "valueChange", void 0);
    HlcClrSelectComponent = HlcClrSelectComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-select',
            template: "<span [class.clr-select-wrapper]=\"!naked\">\r\n    <select\r\n        class=\"hlc-clr-input\"\r\n        [disabled]=\"readonly\"\r\n        (change)=\"onChange($event)\"\r\n        [value]=\"_value\">\r\n        <option\r\n            *ngIf=\"!disallowEmpty\"\r\n            [attr.value]=\"null\"></option>\r\n\r\n        <option\r\n            *ngFor=\"let item of items; trackBy: trackBy\"\r\n            [value]=\"mapKey(item)\" [attr.data]=\"item\">\r\n            {{mapLabel(item)}}\r\n        </option>\r\n    </select>\r\n</span>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrSelectComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [DictMapperService])
    ], HlcClrSelectComponent);
    return HlcClrSelectComponent;
}());

var HlcClrSelectModule = /** @class */ (function () {
    function HlcClrSelectModule() {
    }
    HlcClrSelectModule = __decorate([
        NgModule({
            imports: [BrowserModule, ClrIconModule, ClrDropdownModule, ReactiveFormsModule],
            declarations: [HlcClrSelectComponent],
            exports: [HlcClrSelectComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrSelectModule);
    return HlcClrSelectModule;
}());

var HlcClrDateTimeModule = /** @class */ (function () {
    function HlcClrDateTimeModule() {
    }
    HlcClrDateTimeModule = __decorate([
        NgModule({
            imports: [CommonModule, ClrDatepickerModule, ClrIconModule, HlcClrSelectModule],
            declarations: [HlcClrDateTimeComponent],
            exports: [HlcClrDateTimeComponent],
            providers: [DateConvertService]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrDateTimeModule);
    return HlcClrDateTimeModule;
}());

var HlcClrDisplayComponent = /** @class */ (function () {
    function HlcClrDisplayComponent() {
        this.iconClick = new EventEmitter();
    }
    HlcClrDisplayComponent_1 = HlcClrDisplayComponent;
    //
    HlcClrDisplayComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrDisplayComponent.prototype.registerOnChange = function (_) { };
    HlcClrDisplayComponent.prototype.registerOnTouched = function (_) { };
    Object.defineProperty(HlcClrDisplayComponent.prototype, "formattedValue", {
        get: function () {
            return this.format ? this.format(this.value) : this.value;
        },
        enumerable: true,
        configurable: true
    });
    var HlcClrDisplayComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrDisplayComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], HlcClrDisplayComponent.prototype, "format", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrDisplayComponent.prototype, "icon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrDisplayComponent.prototype, "iconTooltipText", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrDisplayComponent.prototype, "iconClick", void 0);
    HlcClrDisplayComponent = HlcClrDisplayComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-display',
            template: "{{ formattedValue }}\r\n\r\n<clr-tooltip *ngIf=\"iconTooltipText && icon\">\r\n    <button\r\n        clrTooltipTrigger\r\n        class=\"btn btn-link btn-icon btn-sm\"\r\n        type=\"Button\"\r\n        style=\"margin: initial\"\r\n        (click)=\"iconClick.emit(value)\"\r\n    >\r\n        <clr-icon [attr.shape]=\"icon\"></clr-icon>\r\n    </button>\r\n    <clr-tooltip-content clrPosition=\"top-right\" clrSize=\"sm\" *clrIfOpen> <span>Edit</span> </clr-tooltip-content>\r\n</clr-tooltip>\r\n\r\n<button\r\n    *ngIf=\"!iconTooltipText && icon\"\r\n    class=\"btn btn-link btn-icon btn-sm\"\r\n    type=\"Button\"\r\n    style=\"margin: initial\"\r\n    (click)=\"iconClick.emit()\"\r\n>\r\n    <clr-icon [attr.shape]=\"icon\"></clr-icon>\r\n</button>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrDisplayComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        })
    ], HlcClrDisplayComponent);
    return HlcClrDisplayComponent;
}());

var HlcClrDisplayModule = /** @class */ (function () {
    function HlcClrDisplayModule() {
    }
    HlcClrDisplayModule = __decorate([
        NgModule({
            imports: [CommonModule, ClrIconModule, ClrTooltipModule],
            declarations: [HlcClrDisplayComponent],
            exports: [HlcClrDisplayComponent]
        })
    ], HlcClrDisplayModule);
    return HlcClrDisplayModule;
}());

var HlcClrMaskComponent = /** @class */ (function () {
    function HlcClrMaskComponent() {
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
    }
    HlcClrMaskComponent_1 = HlcClrMaskComponent;
    HlcClrMaskComponent.prototype.ngOnInit = function () { };
    Object.defineProperty(HlcClrMaskComponent.prototype, "textMask", {
        get: function () {
            // mask could be set in 2 formats: one full defined mask options and another just mask template string
            // convert all of them to full format here
            return this.mask && (this.mask['mask'] ? this.mask : { mask: this.mask, guide: false });
        },
        enumerable: true,
        configurable: true
    });
    HlcClrMaskComponent.prototype.onChange = function ($event) {
        if (($event.target.value || '') === (this.value || '')) {
            return;
        }
        this.value = $event.target.value;
        var val = this.unmask ? this.unmask(this.value) : this.value;
        this.propagateChange(val);
        this.valueChange.emit(val);
    };
    //
    HlcClrMaskComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrMaskComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrMaskComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrMaskComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrMaskComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrMaskComponent.prototype, "placeholder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrMaskComponent.prototype, "mask", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrMaskComponent.prototype, "unmask", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrMaskComponent.prototype, "valueChange", void 0);
    HlcClrMaskComponent = HlcClrMaskComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-mask',
            template: "<input\r\n    class=\"clr-input\"\r\n    [placeholder]=\"placeholder || ''\"\r\n    [mask]=\"mask\"\r\n    [value]=\"value || ''\"\r\n    (keyup)=\"onChange($event)\"\r\n    type=\"text\">\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrMaskComponent_1; }),
                    multi: true,
                },
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrMaskComponent);
    return HlcClrMaskComponent;
}());

var config = new InjectionToken('config');
var NEW_CONFIG = new InjectionToken('NEW_CONFIG');
var INITIAL_CONFIG = new InjectionToken('INITIAL_CONFIG');
var initialConfig = {
    sufix: '',
    prefix: '',
    clearIfNotMatch: false,
    showTemplate: false,
    showMaskTyped: false,
    dropSpecialCharacters: true,
    specialCharacters: ['/', '(', ')', '.', ':', '-', ' ', '+', ',', '@', '[', ']', '\"', '\''],
    patterns: {
        '0': {
            pattern: new RegExp('\\d'),
        },
        '9': {
            pattern: new RegExp('\\d'),
            optional: true
        },
        'A': {
            pattern: new RegExp('\[a-zA-Z0-9\]')
        },
        'S': {
            pattern: new RegExp('\[a-zA-Z\]')
        },
        'd': {
            pattern: new RegExp('\\d'),
        },
        'm': {
            pattern: new RegExp('\\d'),
        },
    }
};

// tslint:disable
var MaskApplierService = /** @class */ (function () {
    function MaskApplierService(_config) {
        this._config = _config;
        this.maskExpression = '';
        this._shift = new Set();
        this.maskSpecialCharacters = this._config.specialCharacters;
        this.maskAvailablePatterns = this._config.patterns;
        this.clearIfNotMatch = this._config.clearIfNotMatch;
        this.dropSpecialCharacters = this._config.dropSpecialCharacters;
        this.maskSpecialCharacters = this._config.specialCharacters;
        this.maskAvailablePatterns = this._config.patterns;
        this.prefix = this._config.prefix;
        this.sufix = this._config.sufix;
    }
    // tslint:disable-next-line:no-any
    MaskApplierService.prototype.applyMaskWithPattern = function (inputValue, maskAndPattern) {
        var _a = __read(maskAndPattern, 2), mask = _a[0], customPattern = _a[1];
        this.customPattern = customPattern;
        return this.applyMask(inputValue, mask);
    };
    MaskApplierService.prototype.applyMask = function (inputValue, maskExpression, position, cb) {
        if (position === void 0) { position = 0; }
        if (cb === void 0) { cb = function () { }; }
        if (inputValue === undefined || inputValue === null || maskExpression === undefined) {
            return '';
        }
        var cursor = 0;
        var result = "";
        var multi = false;
        if (inputValue.slice(0, this.prefix.length) === this.prefix) {
            inputValue = inputValue.slice(this.prefix.length, inputValue.length);
        }
        var inputArray = inputValue.toString()
            .split('');
        // tslint:disable-next-line
        for (var i = 0, inputSymbol = inputArray[0]; i
            < inputArray.length; i++, inputSymbol = inputArray[i]) {
            if (cursor === maskExpression.length) {
                break;
            }
            if (this._checkSymbolMask(inputSymbol, maskExpression[cursor]) && maskExpression[cursor + 1] === '?') {
                result += inputSymbol;
                cursor += 2;
            }
            else if (maskExpression[cursor + 1] === '*' && multi
                && this._checkSymbolMask(inputSymbol, maskExpression[cursor + 2])) {
                result += inputSymbol;
                cursor += 3;
                multi = false;
            }
            else if (this._checkSymbolMask(inputSymbol, maskExpression[cursor])
                && maskExpression[cursor + 1]
                    === '*') {
                result += inputSymbol;
                multi = true;
            }
            else if (maskExpression[cursor + 1] === '?' && this._checkSymbolMask(inputSymbol, maskExpression[cursor + 2])) {
                result += inputSymbol;
                cursor += 3;
            }
            else if (this._checkSymbolMask(inputSymbol, maskExpression[cursor])) {
                if (maskExpression[cursor] === 'd') {
                    if (Number(inputSymbol) > 3) {
                        result += 0;
                        cursor += 1;
                        var shiftStep = /\*|\?/g.test(maskExpression.slice(0, cursor))
                            ? inputArray.length
                            : cursor;
                        this._shift.add(shiftStep + this.prefix.length || 0);
                        i--;
                        continue;
                    }
                }
                if (maskExpression[cursor - 1] === 'd') {
                    if (Number(inputValue.slice(cursor - 1, cursor + 1)) > 31) {
                        continue;
                    }
                }
                if (maskExpression[cursor] === 'm') {
                    if (Number(inputSymbol) > 1) {
                        result += 0;
                        cursor += 1;
                        var shiftStep = /\*|\?/g.test(maskExpression.slice(0, cursor))
                            ? inputArray.length
                            : cursor;
                        this._shift.add(shiftStep + this.prefix.length || 0);
                        i--;
                        continue;
                    }
                }
                if (maskExpression[cursor - 1] === 'm') {
                    if (Number(inputValue.slice(cursor - 1, cursor + 1)) > 12) {
                        continue;
                    }
                }
                result += inputSymbol;
                cursor++;
            }
            else if (this.maskSpecialCharacters.indexOf(maskExpression[cursor]) !== -1) {
                result += maskExpression[cursor];
                cursor++;
                var shiftStep = /\*|\?/g.test(maskExpression.slice(0, cursor))
                    ? inputArray.length
                    : cursor;
                this._shift.add(shiftStep + this.prefix.length || 0);
                i--;
            }
            else if (this.maskSpecialCharacters.indexOf(inputSymbol) > -1
                && this.maskAvailablePatterns[maskExpression[cursor]]
                && this.maskAvailablePatterns[maskExpression[cursor]].optional) {
                cursor++;
                i--;
            }
            else if ((this.maskExpression[cursor + 1] === '*')
                && (this._findSpecialChar(this.maskExpression[cursor + 2]))
                && (this._findSpecialChar(inputSymbol) === this.maskExpression[cursor + 2])) {
                cursor += 3;
                result += inputSymbol;
            }
        }
        if (result.length + 1 === maskExpression.length
            && this.maskSpecialCharacters.indexOf(maskExpression[maskExpression.length - 1]) !== -1) {
            result += maskExpression[maskExpression.length - 1];
        }
        var shift = 1;
        var newPosition = position + 1;
        while (this._shift.has(newPosition)) {
            shift++;
            newPosition++;
        }
        cb(this._shift.has(position) ? shift : 0);
        var res = "" + this.prefix + result;
        res = this.sufix &&
            cursor === maskExpression.length
            ? "" + this.prefix + result + this.sufix
            : "" + this.prefix + result;
        return res;
    };
    MaskApplierService.prototype._findSpecialChar = function (inputSymbol) {
        var symbol = this.maskSpecialCharacters
            .find(function (val) { return val === inputSymbol; });
        return symbol;
    };
    MaskApplierService.prototype._checkSymbolMask = function (inputSymbol, maskSymbol) {
        this.maskAvailablePatterns = this.customPattern
            ? this.customPattern
            : this.maskAvailablePatterns;
        return this.maskAvailablePatterns[maskSymbol]
            && this.maskAvailablePatterns[maskSymbol].pattern
            && this.maskAvailablePatterns[maskSymbol].pattern.test(inputSymbol);
    };
    MaskApplierService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [config,] }] }
    ]; };
    MaskApplierService = __decorate([
        Injectable(),
        __param(0, Inject(config)),
        __metadata("design:paramtypes", [Object])
    ], MaskApplierService);
    return MaskApplierService;
}());

// tslint:disable
var MaskService = /** @class */ (function (_super) {
    __extends(MaskService, _super);
    function MaskService(
    // tslint:disable-next-line
    document, _config, _elementRef, _renderer) {
        var _this = _super.call(this, _config) || this;
        _this.document = document;
        _this._config = _config;
        _this._elementRef = _elementRef;
        _this._renderer = _renderer;
        _this.maskExpression = '';
        _this.isNumberValue = false;
        _this.showMaskTyped = false;
        _this.maskIsShown = '';
        // tslint:disable-next-line
        _this.onChange = function (_) { };
        _this.onTouch = function () { };
        _this._formElement = _this._elementRef.nativeElement;
        return _this;
    }
    MaskService.prototype.applyMask = function (inputValue, maskExpression, position, cb) {
        if (position === void 0) { position = 0; }
        if (cb === void 0) { cb = function () { }; }
        this.maskIsShown = this.showMaskTyped
            ? this.maskExpression.replace(/[0-9]/g, '_')
            : '';
        if (!inputValue && this.showMaskTyped) {
            return this.prefix + this.maskIsShown;
        }
        var result = _super.prototype.applyMask.call(this, inputValue, maskExpression, position, cb);
        Array.isArray(this.dropSpecialCharacters)
            ? this.onChange(this._removeMask(this._removeSufix(this._removePrefix(result)), this.dropSpecialCharacters))
            : this.dropSpecialCharacters === true
                ? this.onChange(this.isNumberValue
                    ? Number(this._removeMask(this._removeSufix(this._removePrefix(result)), this.maskSpecialCharacters))
                    : this._removeMask(this._removeSufix(this._removePrefix(result)), this.maskSpecialCharacters))
                : this.onChange(this._removeSufix(this._removePrefix(result)));
        var ifMaskIsShown = '';
        if (!this.showMaskTyped) {
            return result;
        }
        var resLen = result.length;
        var prefNmask = this.prefix + this.maskIsShown;
        ifMaskIsShown = prefNmask.slice(resLen);
        return result + ifMaskIsShown;
    };
    MaskService.prototype.applyValueChanges = function (position, cb) {
        if (position === void 0) { position = 0; }
        if (cb === void 0) { cb = function () { }; }
        var maskedInput = this.applyMask(this._formElement.value, this.maskExpression, position, cb);
        this._formElement.value = maskedInput;
        if (this._formElement === this.document.activeElement) {
            return;
        }
        this.clearIfNotMatchFn();
    };
    MaskService.prototype.showMaskInInput = function () {
        if (this.showMaskTyped) {
            this.maskIsShown = this.maskExpression.replace(/[0-9]/g, '_');
        }
    };
    MaskService.prototype.clearIfNotMatchFn = function () {
        if (this.clearIfNotMatch === true &&
            this.maskExpression.length !== this._formElement.value.length) {
            this.formElementProperty = ['value', ''];
            this.applyMask(this._formElement.value, this.maskExpression);
        }
    };
    Object.defineProperty(MaskService.prototype, "formElementProperty", {
        set: function (_a) {
            var _b = __read(_a, 2), name = _b[0], value = _b[1];
            this._renderer.setProperty(this._formElement, name, value);
        },
        enumerable: true,
        configurable: true
    });
    MaskService.prototype._removeMask = function (value, specialCharactersForRemove) {
        return value
            ? value.replace(this._regExpForRemove(specialCharactersForRemove), '')
            : value;
    };
    MaskService.prototype._removePrefix = function (value) {
        if (!this.prefix) {
            return value;
        }
        return value
            ? value.replace(this.prefix, '')
            : value;
    };
    MaskService.prototype._removeSufix = function (value) {
        if (!this.sufix) {
            return value;
        }
        return value
            ? value.replace(this.sufix, '')
            : value;
    };
    MaskService.prototype._regExpForRemove = function (specialCharactersForRemove) {
        return new RegExp(specialCharactersForRemove.map(function (item) { return "\\" + item; }).join('|'), 'gi');
    };
    MaskService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: undefined, decorators: [{ type: Inject, args: [config,] }] },
        { type: ElementRef },
        { type: Renderer2 }
    ]; };
    MaskService.ɵprov = ɵɵdefineInjectable({ factory: function MaskService_Factory() { return new MaskService(ɵɵinject(DOCUMENT), ɵɵinject(config), ɵɵinject(ElementRef), ɵɵinject(Renderer2)); }, token: MaskService, providedIn: "root" });
    MaskService = __decorate([
        Injectable({ providedIn: 'root' }),
        __param(0, Inject(DOCUMENT)),
        __param(1, Inject(config)),
        __metadata("design:paramtypes", [Object, Object, ElementRef,
            Renderer2])
    ], MaskService);
    return MaskService;
}(MaskApplierService));

// tslint:disable
var MaskDirective = /** @class */ (function () {
    function MaskDirective(
    // tslint:disable-next-line
    document, _maskService) {
        this.document = document;
        this._maskService = _maskService;
        this._position = null;
        // tslint:disable-next-line
        this.onChange = function (_) { };
        this.onTouch = function () { };
    }
    MaskDirective_1 = MaskDirective;
    Object.defineProperty(MaskDirective.prototype, "maskExpression", {
        set: function (value) {
            this._maskValue = value || '';
            if (!this._maskValue) {
                return;
            }
            this._maskService.maskExpression = this._repeatPatternSymbols(this._maskValue);
            this._maskService.formElementProperty = [
                'value',
                this._maskService.applyMask(this._inputValue, this._maskService.maskExpression)
            ];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MaskDirective.prototype, "specialCharacters", {
        set: function (value) {
            if (!value ||
                !Array.isArray(value) ||
                (Array.isArray(value) && !value.length)) {
                return;
            }
            this._maskService.maskSpecialCharacters = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MaskDirective.prototype, "patterns", {
        set: function (value) {
            if (!value) {
                return;
            }
            this._maskService.maskAvailablePatterns = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MaskDirective.prototype, "prefix", {
        set: function (value) {
            if (!value) {
                return;
            }
            this._maskService.prefix = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MaskDirective.prototype, "sufix", {
        set: function (value) {
            if (!value) {
                return;
            }
            this._maskService.sufix = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MaskDirective.prototype, "dropSpecialCharacters", {
        set: function (value) {
            this._maskService.dropSpecialCharacters = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MaskDirective.prototype, "showMaskTyped", {
        set: function (value) {
            if (!value) {
                return;
            }
            this._maskService.showMaskTyped = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MaskDirective.prototype, "showTemplate", {
        set: function (value) {
            this._maskService.showTemplate = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MaskDirective.prototype, "clearIfNotMatch", {
        set: function (value) {
            this._maskService.clearIfNotMatch = value;
        },
        enumerable: true,
        configurable: true
    });
    MaskDirective.prototype.onInput = function (e) {
        var el = e.target;
        this._inputValue = el.value;
        if (!this._maskValue) {
            this.onChange(el.value);
            return;
        }
        var position = el.selectionStart === 1
            ? el.selectionStart + this._maskService.prefix.length
            : el.selectionStart;
        var caretShift = 0;
        this._maskService.applyValueChanges(position, function (shift) { return (caretShift = shift); });
        // only set the selection if the element is active
        if (this.document.activeElement !== el) {
            return;
        }
        el.selectionStart = el.selectionEnd =
            this._position !== null
                ? this._position
                : position +
                    // tslint:disable-next-line
                    (e.inputType === 'deleteContentBackward' ? 0 : caretShift);
        this._position = null;
    };
    MaskDirective.prototype.onBlur = function () {
        this._maskService.clearIfNotMatchFn();
        this.onTouch();
    };
    MaskDirective.prototype.onFocus = function (e) {
        var el = e.target;
        if (el !== null && el.selectionStart !== null &&
            el.selectionStart === el.selectionEnd &&
            el.selectionStart > this._maskService.prefix.length &&
            // tslint:disable-next-line
            e.keyCode !== 38) {
            return;
        }
        if (this._maskService.showMaskTyped) {
            this._maskService.maskIsShown = this._maskService.maskExpression.replace(/[0-9]/g, '_');
        }
        el.value = !el.value || el.value === this._maskService.prefix
            ? this._maskService.prefix + this._maskService.maskIsShown
            : el.value;
        /** fix of cursor position with prefix when mouse click occur */
        if ((el.selectionStart || el.selectionEnd) <= this._maskService.prefix.length) {
            el.selectionStart = this._maskService.prefix.length;
            return;
        }
    };
    MaskDirective.prototype.a = function (e) {
        var el = e.target;
        if (e.keyCode === 38) {
            e.preventDefault();
        }
        if (e.keyCode === 37 || e.keyCode === 8) {
            if (el.selectionStart <= this._maskService.prefix.length
                && el.selectionEnd <= this._maskService.prefix.length) {
                e.preventDefault();
            }
            this.onFocus(e);
            if (e.keyCode === 8
                && el.selectionStart === 0
                && el.selectionEnd === el.value.length) {
                el.value = this._maskService.prefix;
                this._position = this._maskService.prefix ? this._maskService.prefix.length : 1;
                this.onInput(e);
            }
        }
    };
    MaskDirective.prototype.onPaste = function () {
        this._position = Number.MAX_SAFE_INTEGER;
    };
    /** It writes the value in the input */
    MaskDirective.prototype.writeValue = function (inputValue) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (inputValue === undefined) {
                    inputValue = '';
                }
                if (typeof inputValue === 'number') {
                    inputValue = String(inputValue);
                    this._maskService.isNumberValue = true;
                }
                inputValue && this._maskService.maskExpression ||
                    this._maskService.maskExpression && (this._maskService.prefix || this._maskService.showMaskTyped)
                    ? (this._maskService.formElementProperty = [
                        'value',
                        this._maskService.applyMask(inputValue, this._maskService.maskExpression)
                    ])
                    : (this._maskService.formElementProperty = ['value', inputValue]);
                this._inputValue = inputValue;
                return [2 /*return*/];
            });
        });
    };
    // tslint:disable-next-line
    MaskDirective.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
        this._maskService.onChange = this.onChange;
    };
    // tslint:disable-next-line
    MaskDirective.prototype.registerOnTouched = function (fn) {
        this.onTouch = fn;
    };
    /** It disables the input element */
    MaskDirective.prototype.setDisabledState = function (isDisabled) {
        this._maskService.formElementProperty = ['disabled', isDisabled];
    };
    MaskDirective.prototype._repeatPatternSymbols = function (maskExp) {
        var _this = this;
        return maskExp.match(/{[0-9]+}/)
            && maskExp.split('')
                .reduce(function (accum, currval, index) {
                _this._start = (currval === '{') ? index : _this._start;
                if (currval !== '}') {
                    return _this._maskService._findSpecialChar(currval) ? accum + currval : accum;
                }
                _this._end = index;
                var repeatNumber = Number(maskExp
                    .slice(_this._start + 1, _this._end));
                var repaceWith = new Array(repeatNumber + 1)
                    .join(maskExp[_this._start - 1]);
                return accum + repaceWith;
            }, '') || maskExp;
    };
    var MaskDirective_1;
    MaskDirective.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: MaskService }
    ]; };
    __decorate([
        Input('mask'),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], MaskDirective.prototype, "maskExpression", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], MaskDirective.prototype, "specialCharacters", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], MaskDirective.prototype, "patterns", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], MaskDirective.prototype, "prefix", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], MaskDirective.prototype, "sufix", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], MaskDirective.prototype, "dropSpecialCharacters", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], MaskDirective.prototype, "showMaskTyped", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], MaskDirective.prototype, "showTemplate", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], MaskDirective.prototype, "clearIfNotMatch", null);
    __decorate([
        HostListener('input', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [KeyboardEvent]),
        __metadata("design:returntype", void 0)
    ], MaskDirective.prototype, "onInput", null);
    __decorate([
        HostListener('blur'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], MaskDirective.prototype, "onBlur", null);
    __decorate([
        HostListener('click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], MaskDirective.prototype, "onFocus", null);
    __decorate([
        HostListener('keydown', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [KeyboardEvent]),
        __metadata("design:returntype", void 0)
    ], MaskDirective.prototype, "a", null);
    __decorate([
        HostListener('paste'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], MaskDirective.prototype, "onPaste", null);
    MaskDirective = MaskDirective_1 = __decorate([
        Directive({
            selector: '[mask]',
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return MaskDirective_1; }),
                    multi: true
                },
                MaskService
            ]
        }),
        __param(0, Inject(DOCUMENT)),
        __metadata("design:paramtypes", [Object, MaskService])
    ], MaskDirective);
    return MaskDirective;
}());

var MaskPipe = /** @class */ (function () {
    function MaskPipe(_maskService) {
        this._maskService = _maskService;
    }
    MaskPipe.prototype.transform = function (value, mask) {
        if (!value) {
            return '';
        }
        if (typeof mask === 'string') {
            return this._maskService.applyMask("" + value, mask);
        }
        return this._maskService.applyMaskWithPattern("" + value, mask);
    };
    MaskPipe.ctorParameters = function () { return [
        { type: MaskApplierService }
    ]; };
    MaskPipe = __decorate([
        Pipe({
            name: 'mask',
            pure: true
        }),
        __metadata("design:paramtypes", [MaskApplierService])
    ], MaskPipe);
    return MaskPipe;
}());

var ɵ0$1 = undefined, ɵ1$1 = initialConfig;
var NgxMaskModule = /** @class */ (function () {
    function NgxMaskModule() {
    }
    NgxMaskModule = __decorate([
        NgModule({
            exports: [MaskDirective, MaskPipe],
            declarations: [MaskDirective, MaskPipe],
            providers: [
                {
                    provide: NEW_CONFIG,
                    useValue: ɵ0$1
                },
                {
                    provide: INITIAL_CONFIG,
                    useValue: ɵ1$1
                },
                {
                    provide: config,
                    useFactory: _configFactory,
                    deps: [INITIAL_CONFIG, NEW_CONFIG]
                },
                MaskApplierService
            ]
        })
    ], NgxMaskModule);
    return NgxMaskModule;
}());
/**
 * @internal
 */
function _configFactory(initConfig, configValue) {
    return typeof configValue === 'function' ? configValue() : __assign(__assign({}, initConfig), configValue);
}

var HlcClrMaskModule = /** @class */ (function () {
    function HlcClrMaskModule() {
    }
    HlcClrMaskModule = __decorate([
        NgModule({
            imports: [CommonModule, FormsModule, NgxMaskModule],
            declarations: [HlcClrMaskComponent],
            exports: [HlcClrMaskComponent]
        })
    ], HlcClrMaskModule);
    return HlcClrMaskModule;
}());

var TextMask = /** @class */ (function () {
    function TextMask() {
    }
    TextMask.unmaskStrNumber = function (val) {
        var regex = /[\D|[^.]]+/g;
        return val ? val.replace(regex, '') : null;
    };
    TextMask.unmaskNumber = function (val) {
        var str = TextMask.unmaskStrNumber(val);
        return str ? +str : null;
    };
    TextMask.int = function (n) {
        return repeat('9', n).join('');
    };
    TextMask.float = function (n, i) {
        return repeat('9', n).join('') + '.' + repeat('0', i).join('');
    };
    /*
    static hexColor() {
        const regex = /\d|a|b|c|d|e|f|A|B|C|D|E|F/;
        return ['#', ...R.repeat(regex, 6)];
    }
    */
    TextMask.phone = function () {
        return '+0 (000) 000-0000';
    };
    return TextMask;
}());

var monthYearRequiredValidator = function (c) {
    var val = c.value;
    if (!val || isNil(val.month) || isNil(val.year)) {
        return { required: true };
    }
    else {
        return null;
    }
};

var HlcClrMonthYearSelectComponent = /** @class */ (function () {
    function HlcClrMonthYearSelectComponent(datePipe) {
        this.datePipe = datePipe;
        this.valueChange = new EventEmitter();
        //
        this.propagateChange = function (_) { };
    }
    HlcClrMonthYearSelectComponent_1 = HlcClrMonthYearSelectComponent;
    HlcClrMonthYearSelectComponent.onYearChange = function (it) {
        var yfrom = it.yearFrom || 1960;
        var yto = it.yearTo || new Date().getFullYear();
        it.years = reverse(range(yfrom, yto + 1).map(function (key) { return ({ key: key, label: key.toString() }); }));
        it.months = range(0, 11).map(function (key) {
            var date = new Date().setMonth(key);
            return {
                key: key + 1,
                label: it.datePipe.transform(date, 'LLLL')
            };
        });
    };
    Object.defineProperty(HlcClrMonthYearSelectComponent.prototype, "yearValue", {
        get: function () {
            return this.value && this.value.year;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrMonthYearSelectComponent.prototype, "monthValue", {
        get: function () {
            return this.value && this.value.month;
        },
        enumerable: true,
        configurable: true
    });
    HlcClrMonthYearSelectComponent.prototype.ngOnInit = function () {
        HlcClrMonthYearSelectComponent_1.onYearChange(this);
    };
    HlcClrMonthYearSelectComponent.prototype.onYearChange = function (year) {
        this.onValueChanged(assoc('year', year, this.value || {}));
    };
    HlcClrMonthYearSelectComponent.prototype.onMonthChange = function (month) {
        this.onValueChanged(assoc('month', month, this.value || {}));
    };
    HlcClrMonthYearSelectComponent.prototype.onValueChanged = function (val) {
        this.value = val;
        this.valueChange.emit(val);
        this.propagateChange(val);
    };
    HlcClrMonthYearSelectComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrMonthYearSelectComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrMonthYearSelectComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrMonthYearSelectComponent_1;
    HlcClrMonthYearSelectComponent.ctorParameters = function () { return [
        { type: DatePipe }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrMonthYearSelectComponent.prototype, "value", void 0);
    __decorate([
        OnChange(HlcClrMonthYearSelectComponent_1.onYearChange),
        Input(),
        __metadata("design:type", Number)
    ], HlcClrMonthYearSelectComponent.prototype, "yearFrom", void 0);
    __decorate([
        OnChange(HlcClrMonthYearSelectComponent_1.onYearChange),
        Input(),
        __metadata("design:type", Number)
    ], HlcClrMonthYearSelectComponent.prototype, "yearTo", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrMonthYearSelectComponent.prototype, "valueChange", void 0);
    HlcClrMonthYearSelectComponent = HlcClrMonthYearSelectComponent_1 = __decorate([
        Component({
            selector: 'hlc-month-year-select',
            template: "<hlc-clr-select [items]=\"months\" [value]=\"monthValue\" (valueChange)=\"onMonthChange($event)\"></hlc-clr-select>\r\n<hlc-clr-select [items]=\"years\" [value]=\"yearValue\" (valueChange)=\"onYearChange($event)\"></hlc-clr-select>\r\n",
            providers: [
                DatePipe,
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrMonthYearSelectComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [DatePipe])
    ], HlcClrMonthYearSelectComponent);
    return HlcClrMonthYearSelectComponent;
}());

var HlcClrMonthYearSelectModule = /** @class */ (function () {
    function HlcClrMonthYearSelectModule() {
    }
    HlcClrMonthYearSelectModule = __decorate([
        NgModule({
            imports: [CommonModule, HlcClrSelectModule],
            declarations: [HlcClrMonthYearSelectComponent],
            exports: [HlcClrMonthYearSelectComponent],
            providers: []
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrMonthYearSelectModule);
    return HlcClrMonthYearSelectModule;
}());

var HlcClrMultiSelectComponent = /** @class */ (function () {
    function HlcClrMultiSelectComponent(dictMapperService) {
        var _this = this;
        this.dictMapperService = dictMapperService;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        this.trackBy = function (_, obj) {
            return _this.mapKey(obj);
        };
    }
    HlcClrMultiSelectComponent_1 = HlcClrMultiSelectComponent;
    HlcClrMultiSelectComponent.prototype.ngOnInit = function () { };
    HlcClrMultiSelectComponent.prototype.onChange = function (val) {
        var _this = this;
        this.value = Array.apply(null, val.target.options)
            .map(function (opt, i) { return [opt, i]; })
            .filter(function (_a) {
            var _b = __read(_a, 1), opt = _b[0];
            return opt.selected;
        })
            .map(function (_a) {
            var _b = __read(_a, 2), _ = _b[0], i = _b[1];
            return _this.mapKey(_this.items[i]);
        });
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    HlcClrMultiSelectComponent.prototype.isSelected = function (item) {
        var isSelected = contains(this.mapKey(item), this.value || []);
        return isSelected;
    };
    HlcClrMultiSelectComponent.prototype.mapKey = function (obj) {
        return (this.dictMapper || this.dictMapperService).getKey(obj);
    };
    HlcClrMultiSelectComponent.prototype.mapLabel = function (obj) {
        return (this.dictMapper || this.dictMapperService).getLabel(obj);
    };
    //
    HlcClrMultiSelectComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrMultiSelectComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrMultiSelectComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrMultiSelectComponent_1;
    HlcClrMultiSelectComponent.ctorParameters = function () { return [
        { type: DictMapperService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], HlcClrMultiSelectComponent.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrMultiSelectComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrMultiSelectComponent.prototype, "dictMapper", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrMultiSelectComponent.prototype, "valueChange", void 0);
    HlcClrMultiSelectComponent = HlcClrMultiSelectComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-multi-select',
            template: "<div class=\"clr-multiselect-wrapper\">\r\n    <select multiple (change)=\"onChange($event)\">\r\n        <option *ngFor=\"let item of items; trackBy: trackBy\" [value]=\"mapKey(item)\" [selected]=\"isSelected(item)\">\r\n            {{ mapLabel(item) }}\r\n        </option>\r\n    </select>\r\n</div>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrMultiSelectComponent_1; }),
                    multi: true
                }
            ],
            styles: ["select{width:100%}"]
        }),
        __metadata("design:paramtypes", [DictMapperService])
    ], HlcClrMultiSelectComponent);
    return HlcClrMultiSelectComponent;
}());

var HlcClrMultiSelectModule = /** @class */ (function () {
    function HlcClrMultiSelectModule() {
    }
    HlcClrMultiSelectModule = __decorate([
        NgModule({
            imports: [CommonModule, ReactiveFormsModule, ClrSelectModule],
            declarations: [HlcClrMultiSelectComponent],
            exports: [HlcClrMultiSelectComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrMultiSelectModule);
    return HlcClrMultiSelectModule;
}());

var HlcClrOptionsComponent = /** @class */ (function () {
    function HlcClrOptionsComponent(dictMapper) {
        var _this = this;
        this.dictMapper = dictMapper;
        this.viewType = "simple" /* Simple */;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        this.trackBy = function (_, obj) {
            return _this.mapKey(obj);
        };
    }
    HlcClrOptionsComponent_1 = HlcClrOptionsComponent;
    HlcClrOptionsComponent.prototype.ngOnInit = function () { };
    HlcClrOptionsComponent.prototype.onChange = function (val) {
        if (this.readonly) {
            return;
        }
        this.value = val || null;
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    HlcClrOptionsComponent.prototype.isChecked = function (item) {
        return this.mapKey(item) === this.value;
    };
    HlcClrOptionsComponent.prototype.mapKey = function (obj) {
        return this.dictMapper.getKey(obj);
    };
    HlcClrOptionsComponent.prototype.mapLabel = function (obj) {
        return this.dictMapper.getLabel(obj);
    };
    //
    HlcClrOptionsComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrOptionsComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrOptionsComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrOptionsComponent_1;
    HlcClrOptionsComponent.ctorParameters = function () { return [
        { type: DictMapperService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrOptionsComponent.prototype, "viewType", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], HlcClrOptionsComponent.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrOptionsComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrOptionsComponent.prototype, "readonly", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrOptionsComponent.prototype, "valueChange", void 0);
    HlcClrOptionsComponent = HlcClrOptionsComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-options',
            template: "<ng-container *ngIf=\"viewType === 'simple'; else buttonsView\">\r\n    <clr-radio-wrapper *ngFor=\"let item of items; trackBy: trackBy; let index = index\">\r\n        <input\r\n            [class.disabled]=\"readonly\"\r\n            type=\"radio\"\r\n            clrRadio\r\n            [checked]=\"isChecked(item)\"\r\n            [value]=\"mapKey(item)\"\r\n            (change)=\"onChange($event.target.value)\"\r\n        />\r\n        <label>{{ mapLabel(item) }}</label>\r\n    </clr-radio-wrapper>\r\n</ng-container>\r\n<ng-template #buttonsView>\r\n    <div class=\"btn-group\">\r\n        <div class=\"radio btn\" [class.disabled]=\"readonly\"  *ngFor=\"let item of items; trackBy: trackBy\" (click)=\"onChange(mapKey(item))\">\r\n            <input type=\"radio\" [checked]=\"isChecked(item)\" [value]=\"mapKey(item)\" />\r\n            <label>{{ mapLabel(item) }}</label>\r\n        </div>\r\n    </div>\r\n</ng-template>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrOptionsComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [DictMapperService])
    ], HlcClrOptionsComponent);
    return HlcClrOptionsComponent;
}());

var HlcClrOptionsModule = /** @class */ (function () {
    function HlcClrOptionsModule() {
    }
    HlcClrOptionsModule = __decorate([
        NgModule({
            imports: [CommonModule, ClrRadioModule],
            declarations: [HlcClrOptionsComponent],
            exports: [HlcClrOptionsComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrOptionsModule);
    return HlcClrOptionsModule;
}());

var HlcClrPairsListComponent = /** @class */ (function () {
    function HlcClrPairsListComponent(dictMapper, dictMapperSetter) {
        this.dictMapper = dictMapper;
        this.dictMapperSetter = dictMapperSetter;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        this.trackBy = function (i) {
            return i;
        };
    }
    HlcClrPairsListComponent_1 = HlcClrPairsListComponent;
    HlcClrPairsListComponent.prototype.ngOnInit = function () { };
    HlcClrPairsListComponent.prototype.onChangeKey = function (itemIndex, key) {
        var value = this.value || [];
        // this.dictMapperSetter.setKey(value[itemIndex], key);
        this.value = update(itemIndex, this.dictMapperSetter.setKey(value[itemIndex], key), value);
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    HlcClrPairsListComponent.prototype.onChangeValue = function (itemIndex, label) {
        var value = this.value || [];
        // this.dictMapperSetter.setLabel(value[itemIndex], label);
        this.value = update(itemIndex, this.dictMapperSetter.setLabel(value[itemIndex], label), value);
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    HlcClrPairsListComponent.prototype.onRemove = function (itemIndex) {
        var value = this.value || [];
        this.value = remove(itemIndex, 1, value);
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    HlcClrPairsListComponent.prototype.onAdd = function () {
        var _this = this;
        var value = this.value || [];
        var item = pipe(function (i) { return _this.dictMapperSetter.setKey(i, ''); }, function (i) { return _this.dictMapperSetter.setLabel(i, ''); })({});
        this.value = insert(0, item, value);
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    HlcClrPairsListComponent.prototype.mapKey = function (obj) {
        return this.dictMapper.getKey(obj);
    };
    HlcClrPairsListComponent.prototype.mapLabel = function (obj) {
        return this.dictMapper.getLabel(obj);
    };
    //
    HlcClrPairsListComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrPairsListComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrPairsListComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrPairsListComponent_1;
    HlcClrPairsListComponent.ctorParameters = function () { return [
        { type: DictMapperService },
        { type: DictMapperSetterService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrPairsListComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrPairsListComponent.prototype, "readonly", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrPairsListComponent.prototype, "valueChange", void 0);
    HlcClrPairsListComponent = HlcClrPairsListComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-pairs-list',
            template: "<button type=\"button\" class=\"btn btn-icon btn-sm btn-secondary\" (click)=\"onAdd()\">\r\n    <clr-icon shape=\"plus\"></clr-icon>Add Item\r\n</button>\r\n<div class=\"clr-row\" *ngFor=\"let item of value; trackBy: trackBy; let index = index\">\r\n    <clr-input-container>\r\n        <input type=\"text\" clrInput [value]=\"mapKey(item)\" (keyup)=\"onChangeKey(index, $event.target.value)\" />\r\n    </clr-input-container>\r\n    <clr-input-container>\r\n        <input type=\"text\" clrInput [value]=\"mapLabel(item)\" (keyup)=\"onChangeValue(index, $event.target.value)\" />\r\n    </clr-input-container>\r\n    <button type=\"button\" class=\"btn btn-icon btn-sm btn-link\" style=\"margin-top: 1rem\" (click)=\"onRemove(index)\">\r\n        <clr-icon shape=\"times\"></clr-icon>\r\n    </button>\r\n</div>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrPairsListComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [DictMapperService,
            DictMapperSetterService])
    ], HlcClrPairsListComponent);
    return HlcClrPairsListComponent;
}());

var HlcClrPairsListModule = /** @class */ (function () {
    function HlcClrPairsListModule() {
    }
    HlcClrPairsListModule = __decorate([
        NgModule({
            imports: [CommonModule, ClrInputModule, ClrIconModule],
            declarations: [HlcClrPairsListComponent],
            exports: [HlcClrPairsListComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrPairsListModule);
    return HlcClrPairsListModule;
}());

var HlcClrPasswordComponent = /** @class */ (function () {
    function HlcClrPasswordComponent() {
        this.propagateChange = function (_) { };
    }
    HlcClrPasswordComponent_1 = HlcClrPasswordComponent;
    HlcClrPasswordComponent.prototype.ngOnInit = function () { };
    HlcClrPasswordComponent.prototype.onChange = function ($event) {
        this.value = $event.target.value;
        this.propagateChange($event.target.value);
    };
    //
    HlcClrPasswordComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrPasswordComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrPasswordComponent.prototype.registerOnTouched = function (_) { };
    Object.defineProperty(HlcClrPasswordComponent.prototype, "cleanValue", {
        get: function () {
            return isNil(this.value) ? '' : this.value;
        },
        enumerable: true,
        configurable: true
    });
    var HlcClrPasswordComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrPasswordComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrPasswordComponent.prototype, "placeholder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrPasswordComponent.prototype, "readonly", void 0);
    HlcClrPasswordComponent = HlcClrPasswordComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-password',
            template: "<clr-password-container>\r\n    <input\r\n        class=\"hlc-clr-input\"\r\n        [placeholder]=\"placeholder || ''\"\r\n        [readonly]=\"readonly ? true : undefined\"\r\n        [value]=\"cleanValue\"\r\n        (keyup)=\"onChange($event)\"\r\n        type=\"text\"\r\n        clrPassword\r\n        autocomplete=\"new-password\"\r\n    />\r\n</clr-password-container>\r\n",
            changeDetection: ChangeDetectionStrategy.OnPush,
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrPasswordComponent_1; }),
                    multi: true
                }
            ],
            styles: ["clr-password-container{margin-top:0}"]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrPasswordComponent);
    return HlcClrPasswordComponent;
}());

var HlcClrPasswordModule = /** @class */ (function () {
    function HlcClrPasswordModule() {
    }
    HlcClrPasswordModule = __decorate([
        NgModule({
            imports: [CommonModule, ClrPasswordModule],
            declarations: [HlcClrPasswordComponent],
            exports: [HlcClrPasswordComponent]
        })
    ], HlcClrPasswordModule);
    return HlcClrPasswordModule;
}());

var HLC_CLR_PHONE_CONFIG = new InjectionToken('HLC_CLR_PHONE_CONFIG');
var defaultPhoneConfig = {
    useParts: 'CountryCodeNumber',
    getCountry: function (val) {
        return val && val[0];
    },
    getCode: function (val) {
        return val && val[1];
    },
    getNumber: function (val) {
        return val && val[2];
    },
    concatValue: function (country, code, number) {
        return [country, code, number];
    }
};

var HlcClrPhoneComponent = /** @class */ (function () {
    function HlcClrPhoneComponent(config) {
        this.codeJustFocused = false;
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        this.config = config || defaultPhoneConfig;
    }
    HlcClrPhoneComponent_1 = HlcClrPhoneComponent;
    HlcClrPhoneComponent.prototype.ngOnInit = function () { };
    Object.defineProperty(HlcClrPhoneComponent.prototype, "useCodePart", {
        get: function () {
            return this.config.useParts === 'CountryCodeNumber';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrPhoneComponent.prototype, "countryPart", {
        get: function () {
            return this.config.getCountry(this.value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrPhoneComponent.prototype, "codePart", {
        get: function () {
            return this.config.getCode && this.config.getCode(this.value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrPhoneComponent.prototype, "numberPart", {
        get: function () {
            return this.config.getNumber(this.value);
        },
        enumerable: true,
        configurable: true
    });
    HlcClrPhoneComponent.prototype.onCountryChange = function (val) {
        if (val === this.countryPart) {
            return;
        }
        this.value = this.config.concatValue(val, this.codePart, this.numberPart);
        this.onChange();
    };
    HlcClrPhoneComponent.prototype.onCodeChange = function (val) {
        if (val === this.codePart) {
            return;
        }
        this.value = this.config.concatValue(this.countryPart, val, this.numberPart);
        this.onChange();
        if (this.codeJustFocused) {
            this.codeJustFocused = false;
            return;
        }
        if (val && val.length === 3) {
            this.numberInput.nativeElement.focus();
        }
    };
    HlcClrPhoneComponent.prototype.onNumberChange = function (val) {
        if (val === this.numberPart) {
            return;
        }
        this.value = this.config.concatValue(this.countryPart, this.codePart, val);
        this.onChange();
    };
    //
    HlcClrPhoneComponent.prototype.onCodeFocus = function () {
        this.codeJustFocused = true;
    };
    //
    HlcClrPhoneComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrPhoneComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrPhoneComponent.prototype.registerOnTouched = function (_) { };
    HlcClrPhoneComponent.prototype.onChange = function () {
        this.valueChange.emit(this.value);
        this.propagateChange(this.value);
    };
    var HlcClrPhoneComponent_1;
    HlcClrPhoneComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [HLC_CLR_PHONE_CONFIG,] }] }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrPhoneComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrPhoneComponent.prototype, "placeholder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrPhoneComponent.prototype, "readonly", void 0);
    __decorate([
        ViewChild('numInput', { static: false }),
        __metadata("design:type", ElementRef)
    ], HlcClrPhoneComponent.prototype, "numberInput", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrPhoneComponent.prototype, "valueChange", void 0);
    HlcClrPhoneComponent = HlcClrPhoneComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-phone',
            template: "<div *ngIf=\"!readonly; else readOnly\">\r\n    +<input\r\n        class=\"clr-input hlc-clr-input small-input\"\r\n        [value]=\"countryPart\"\r\n        (keyup)=\"onCountryChange($event.target.value)\"\r\n        type=\"text\"\r\n        mask=\"999\"\r\n    />\r\n    <ng-container *ngIf=\"useCodePart\">\r\n        (<input\r\n            class=\"clr-input hlc-clr-input small-input\"\r\n            [value]=\"codePart\"\r\n            (keyup)=\"onCodeChange($event.target.value)\"\r\n            type=\"text\"\r\n            mask=\"999\"\r\n            (focus)=\"onCodeFocus()\"\r\n        />)\r\n    </ng-container>\r\n    <input\r\n        #numInput\r\n        class=\"clr-input hlc-clr-input normal-input\"\r\n        [value]=\"numberPart\"\r\n        (keyup)=\"onNumberChange($event.target.value)\"\r\n        type=\"text\"\r\n        mask=\"9999999\"\r\n    />\r\n</div>\r\n<ng-template #readOnly>\r\n    <span class=\"label-readonly\">\r\n        +{{countryPart}} <ng-container *ngIf=\"useCodePart\">({{codePart}})</ng-container> {{numberPart}}\r\n    </span>\r\n</ng-template>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrPhoneComponent_1; }),
                    multi: true
                }
            ],
            styles: [".small-input{width:40px;min-width:40px}.normal-input{width:100px;min-width:100px}.label-readonly{color:#000}"]
        }),
        __param(0, Optional()), __param(0, Inject(HLC_CLR_PHONE_CONFIG)),
        __metadata("design:paramtypes", [Object])
    ], HlcClrPhoneComponent);
    return HlcClrPhoneComponent;
}());

var HlcClrPhoneModule = /** @class */ (function () {
    function HlcClrPhoneModule() {
    }
    HlcClrPhoneModule = __decorate([
        NgModule({
            imports: [CommonModule, NgxMaskModule],
            declarations: [HlcClrPhoneComponent],
            exports: [HlcClrPhoneComponent]
        })
    ], HlcClrPhoneModule);
    return HlcClrPhoneModule;
}());

var TypeaheadMapperService = /** @class */ (function () {
    function TypeaheadMapperService() {
    }
    TypeaheadMapperService.prototype.getKey = function (item) {
        return item['key'];
    };
    TypeaheadMapperService.prototype.getLabel = function (item) {
        return item['label'];
    };
    TypeaheadMapperService.prototype.getDescription = function (item) {
        return item['label'];
    };
    TypeaheadMapperService.ɵprov = ɵɵdefineInjectable({ factory: function TypeaheadMapperService_Factory() { return new TypeaheadMapperService(); }, token: TypeaheadMapperService, providedIn: "root" });
    TypeaheadMapperService = __decorate([
        Injectable({ providedIn: 'root' })
    ], TypeaheadMapperService);
    return TypeaheadMapperService;
}());
var TypeaheadStrMapperService = /** @class */ (function () {
    function TypeaheadStrMapperService() {
    }
    TypeaheadStrMapperService.prototype.getKey = function (item) {
        return item;
    };
    TypeaheadStrMapperService.prototype.getLabel = function (item) {
        return item;
    };
    return TypeaheadStrMapperService;
}());

var HlcClrTypeaheadComponent = /** @class */ (function () {
    function HlcClrTypeaheadComponent(mapper) {
        var _this = this;
        this.mapper = mapper;
        this.valueChange = new EventEmitter();
        this.addNew = new EventEmitter();
        this.propagateChange = function (_) { };
        this.getLabel = function (obj) {
            return _this.config && _this.config.mapper ? obj[_this.config.mapper.getLabel(obj)] : _this.mapper.getLabel(obj);
        };
    }
    HlcClrTypeaheadComponent_1 = HlcClrTypeaheadComponent;
    HlcClrTypeaheadComponent.prototype.ngOnInit = function () { };
    HlcClrTypeaheadComponent.prototype.getKey = function (obj) {
        return this.config && this.config.mapper ? this.config.mapper.getKey(obj) : this.mapper.getKey(obj);
    };
    HlcClrTypeaheadComponent.prototype.getDescription = function (obj) {
        return this.config && this.config.mapper && this.config.mapper.getDescription
            ? this.config.mapper.getDescription(obj)
            : this.mapper.getDescription
                ? this.mapper.getDescription(obj)
                : null;
    };
    Object.defineProperty(HlcClrTypeaheadComponent.prototype, "search", {
        get: function () {
            return this.config && this.config.search;
        },
        enumerable: true,
        configurable: true
    });
    HlcClrTypeaheadComponent.prototype.onChange = function ($event) {
        this.value = $event;
        this.propagateChange(this.value);
        this.valueChange.emit(this.value);
    };
    HlcClrTypeaheadComponent.prototype.resetValue = function () {
        this.value = undefined;
        this.input.nativeElement.value = '';
    };
    //
    HlcClrTypeaheadComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrTypeaheadComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrTypeaheadComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrTypeaheadComponent_1;
    HlcClrTypeaheadComponent.ctorParameters = function () { return [
        { type: TypeaheadMapperService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTypeaheadComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTypeaheadComponent.prototype, "config", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTypeaheadComponent.prototype, "readonly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrTypeaheadComponent.prototype, "placeholder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrTypeaheadComponent.prototype, "allowAddNew", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrTypeaheadComponent.prototype, "valueChange", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrTypeaheadComponent.prototype, "addNew", void 0);
    __decorate([
        ViewChild('input', { static: false }),
        __metadata("design:type", Object)
    ], HlcClrTypeaheadComponent.prototype, "input", void 0);
    HlcClrTypeaheadComponent = HlcClrTypeaheadComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-typeahead',
            template: "<input\r\n    #input\r\n    type=\"text\"\r\n    [placeholder]=\"placeholder || ''\"\r\n    [hlcTypeahead]=\"search\"\r\n    [value]=\"value\"\r\n    [resultTemplate]=\"result\"\r\n    [resultFormatter]=\"getLabel\"\r\n    [allowAddNew]=\"allowAddNew\"\r\n    (valueChange)=\"onChange($event)\"\r\n    (addNew)=\"addNew.emit($event)\">\r\n<ng-template\r\n    #result\r\n    let-item>\r\n    <span [innerHtml]=\"getLabel(item)\"></span>\r\n    <!--\r\n    <div\r\n        class=\"description\"\r\n        *ngIf=\"getDescription(item)\">\r\n        {{getDescription(item)}}\r\n    </div>\r\n    -->\r\n</ng-template>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrTypeaheadComponent_1; }),
                    multi: true
                }
            ],
            styles: ["::ng-deep .hlc-typeahead-result-item.active{background-color:#1e90ff;color:#fff}::ng-deep .hlc-typeahead-result-item em{font-weight:700}::ng-deep .hlc-typeahead-results-container{background-color:#fff}.description{color:#a9a9a9;font-size:x-small}"]
        }),
        __metadata("design:paramtypes", [TypeaheadMapperService])
    ], HlcClrTypeaheadComponent);
    return HlcClrTypeaheadComponent;
}());

var HlcClrTagsComponent = /** @class */ (function () {
    function HlcClrTagsComponent(dictMapper) {
        var _this = this;
        this.dictMapper = dictMapper;
        this.value$ = new BehaviorSubject([]);
        this.showSorted = true;
        this.addNew = new EventEmitter();
        this.propagateChange = function (_) { };
        this.search = function (args$) {
            return _this.config
                .search(args$)
                .pipe(withLatestFrom(_this.value$, function (items, val) { return _this.filterItems(val || [])(items); }));
        };
        this.filterItems = function (excl) { return function (items) {
            return items.filter(function (item) {
                item = cleanupTypeaheadValue(item);
                return !excl.some(function (i) { return _this.dictMapper.getKey(i) === _this.dictMapper.getKey(item); });
            });
        }; };
    }
    HlcClrTagsComponent_1 = HlcClrTagsComponent;
    Object.defineProperty(HlcClrTagsComponent.prototype, "value", {
        get: function () {
            return this.value$.getValue();
        },
        set: function (val) {
            this.value$.next(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrTagsComponent.prototype, "_config", {
        get: function () {
            if (!this.config) {
                return;
            }
            // modify default search, remove already selected tags
            return __assign(__assign({}, this.config), { search: this.search });
        },
        enumerable: true,
        configurable: true
    });
    HlcClrTagsComponent.prototype.onChange = function ($event) {
        this.value = __spread((this.value || []), [$event]);
        this.typeahead.resetValue();
        this.propagateChange(this.value);
    };
    HlcClrTagsComponent.prototype.onRemove = function (item) {
        this.value = this.filterItem(item, this.value);
        this.propagateChange(this.value);
    };
    HlcClrTagsComponent.prototype.onAddNew = function (text) {
        this.value = __spread((this.value || []), [text]);
        this.typeahead.resetValue();
        this.propagateChange(this.value);
        this.addNew.emit(text);
    };
    Object.defineProperty(HlcClrTagsComponent.prototype, "sortedValue", {
        //
        get: function () {
            var sort = is(Function, this.showSorted) ? this.showSorted : this.dictMapper.getLabel.bind(this.dictMapper);
            return this.value && sortBy(sort, this.value);
        },
        enumerable: true,
        configurable: true
    });
    //
    HlcClrTagsComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrTagsComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrTagsComponent.prototype.registerOnTouched = function (_) { };
    //
    HlcClrTagsComponent.prototype.filterItem = function (item, items) {
        var _this = this;
        return items.filter(function (i) { return _this.dictMapper.getKey(i) !== _this.dictMapper.getKey(item); });
    };
    var HlcClrTagsComponent_1;
    HlcClrTagsComponent.ctorParameters = function () { return [
        { type: DictMapperService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [Array])
    ], HlcClrTagsComponent.prototype, "value", null);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTagsComponent.prototype, "config", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTagsComponent.prototype, "readonly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrTagsComponent.prototype, "allowAddNew", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTagsComponent.prototype, "placeholder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTagsComponent.prototype, "showSorted", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrTagsComponent.prototype, "addNew", void 0);
    __decorate([
        ViewChild(HlcClrTypeaheadComponent, { static: false }),
        __metadata("design:type", HlcClrTypeaheadComponent)
    ], HlcClrTagsComponent.prototype, "typeahead", void 0);
    HlcClrTagsComponent = HlcClrTagsComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-tags',
            template: "<hlc-clr-tags-list [items]=\"showSorted ? sortedValue : value\" (remove)=\"onRemove($event)\"></hlc-clr-tags-list>\r\n<hlc-clr-typeahead\r\n    #typeahead\r\n    [config]=\"_config\"\r\n    [placeholder]=\"placeholder\"\r\n    [allowAddNew]=\"allowAddNew\"\r\n    (addNew)=\"onAddNew($event)\"\r\n    (valueChange)=\"onChange($event)\"\r\n></hlc-clr-typeahead>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrTagsComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [DictMapperService])
    ], HlcClrTagsComponent);
    return HlcClrTagsComponent;
}());

var HlcClrTagsListComponent = /** @class */ (function () {
    function HlcClrTagsListComponent(dictMapper) {
        this.dictMapper = dictMapper;
        this.remove = new EventEmitter();
    }
    HlcClrTagsListComponent.prototype.ngOnInit = function () { };
    HlcClrTagsListComponent.prototype.onRemove = function (item) {
        this.remove.emit(item);
    };
    HlcClrTagsListComponent.prototype.trackById = function (_, item) {
        return this.dictMapper.getKey(item);
    };
    HlcClrTagsListComponent.prototype.getLabel = function (item) {
        return this.dictMapper.getLabel(item);
    };
    HlcClrTagsListComponent.ctorParameters = function () { return [
        { type: DictMapperService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], HlcClrTagsListComponent.prototype, "items", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrTagsListComponent.prototype, "remove", void 0);
    HlcClrTagsListComponent = __decorate([
        Component({
            selector: 'hlc-clr-tags-list',
            template: "<ng-container *ngIf=\"items?.length\">\r\n    <div class=\"cat-field__group\">\r\n        <a\r\n            class=\"label label-info clickable tag-item\"\r\n            *ngFor=\"let item of items\"\r\n            (click)=\"onRemove(item)\">\r\n            <clr-icon shape=\"trash\"></clr-icon>\r\n            {{getLabel(item)}}\r\n        </a>\r\n    </div>\r\n</ng-container>\r\n",
            styles: [".cat-field__selector{display:block;margin-top:1rem}.tag-item{margin-bottom:.2rem}"]
        }),
        __metadata("design:paramtypes", [DictMapperService])
    ], HlcClrTagsListComponent);
    return HlcClrTagsListComponent;
}());

var HlcClrTagsListModule = /** @class */ (function () {
    function HlcClrTagsListModule() {
    }
    HlcClrTagsListModule = __decorate([
        NgModule({
            imports: [CommonModule, ClrIconModule],
            declarations: [HlcClrTagsListComponent],
            exports: [HlcClrTagsListComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrTagsListModule);
    return HlcClrTagsListModule;
}());

var HlcClrTypeaheadModule = /** @class */ (function () {
    function HlcClrTypeaheadModule() {
    }
    HlcClrTypeaheadModule = __decorate([
        NgModule({
            imports: [CommonModule, HlcTypeaheadDirectiveModule],
            declarations: [HlcClrTypeaheadComponent],
            exports: [HlcClrTypeaheadComponent],
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrTypeaheadModule);
    return HlcClrTypeaheadModule;
}());

var HlcClrTagsModule = /** @class */ (function () {
    function HlcClrTagsModule() {
    }
    HlcClrTagsModule = __decorate([
        NgModule({
            imports: [CommonModule, HlcClrTypeaheadModule, FormsModule, HlcClrTagsListModule],
            declarations: [HlcClrTagsComponent],
            exports: [HlcClrTagsComponent]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrTagsModule);
    return HlcClrTagsModule;
}());

var HlcClrTextAreaComponent = /** @class */ (function () {
    function HlcClrTextAreaComponent() {
        this.propagateChange = function (_) { };
    }
    HlcClrTextAreaComponent_1 = HlcClrTextAreaComponent;
    HlcClrTextAreaComponent.prototype.ngOnInit = function () { };
    HlcClrTextAreaComponent.prototype.onChange = function ($event) {
        if (this.value === undefined && !$event.target.value) {
            // when user set first time focus on empty field don't change null -> ''.
            // Behaviour consistent with text component.
            return;
        }
        this.value = $event.target.value;
        this.propagateChange($event.target.value);
    };
    HlcClrTextAreaComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrTextAreaComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrTextAreaComponent.prototype.registerOnTouched = function (_) { };
    Object.defineProperty(HlcClrTextAreaComponent.prototype, "cleanValue", {
        get: function () {
            return isNil(this.value) ? '' : this.value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrTextAreaComponent.prototype, "leftCounter", {
        get: function () {
            return isNil(this.maxLength) ? null : this.maxLength - (isNil(this.value) ? 0 : this.value.length);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrTextAreaComponent.prototype, "counterStyle", {
        get: function () {
            if (isNil(this.leftCounter)) {
                return null;
            }
            else if (this.leftCounter < 0) {
                return 'text-counter-danger';
            }
            else if (!isNil(this.warningLimit) && !isNil(this.maxLength) && this.warningLimit > this.leftCounter) {
                return 'text-counter-warning';
            }
        },
        enumerable: true,
        configurable: true
    });
    var HlcClrTextAreaComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrTextAreaComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrTextAreaComponent.prototype, "placeholder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrTextAreaComponent.prototype, "readonly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], HlcClrTextAreaComponent.prototype, "rows", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTextAreaComponent.prototype, "maxLength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTextAreaComponent.prototype, "warningLimit", void 0);
    HlcClrTextAreaComponent = HlcClrTextAreaComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-text-area',
            template: "<div class=\"clr-textarea-wrapper\">\r\n    <textarea\r\n        class=\"clr-textarea\"\r\n        [placeholder]=\"placeholder || ''\"\r\n        [readonly]=\"readonly ? true : undefined\"\r\n        [value]=\"cleanValue\"\r\n        [rows]=\"rows\"\r\n        (keyup)=\"onChange($event)\"\r\n    ></textarea>\r\n    <span *ngIf=\"maxLength\" class=\"text-counter\" [ngClass]=\"counterStyle\">\r\n        <span>{{ maxLength - leftCounter }}</span> / <span>{{maxLength}}</span>\r\n    </span>\r\n</div>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrTextAreaComponent_1; }),
                    multi: true
                }
            ],
            styles: ["::ng-deep textarea{border-color:#f6f6f6;border-bottom:1px solid #9a9a9a;background-color:transparent}::ng-deep textarea:focus{box-shadow:none;border-bottom:2px solid #0094d2}::ng-deep textarea:-moz-read-only{border-width:0;box-shadow:none!important}::ng-deep textarea:read-only{border-width:0;box-shadow:none!important}"]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrTextAreaComponent);
    return HlcClrTextAreaComponent;
}());

var HlcClrTextAreaModule = /** @class */ (function () {
    function HlcClrTextAreaModule() {
    }
    HlcClrTextAreaModule = __decorate([
        NgModule({
            imports: [CommonModule, FormsModule, ClrTextareaModule],
            declarations: [HlcClrTextAreaComponent],
            exports: [HlcClrTextAreaComponent],
            entryComponents: [HlcClrTextAreaComponent]
        })
    ], HlcClrTextAreaModule);
    return HlcClrTextAreaModule;
}());

var HlcClrTextComponent = /** @class */ (function () {
    function HlcClrTextComponent() {
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
    }
    HlcClrTextComponent_1 = HlcClrTextComponent;
    HlcClrTextComponent.prototype.ngOnInit = function () { };
    HlcClrTextComponent.prototype.onChange = function ($event) {
        this.value = $event.target.value;
        this.valueChange.emit(this.value);
        this.propagateChange($event.target.value);
    };
    //
    HlcClrTextComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrTextComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrTextComponent.prototype.registerOnTouched = function (_) { };
    Object.defineProperty(HlcClrTextComponent.prototype, "cleanValue", {
        get: function () {
            return isNil(this.value) ? '' : this.value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrTextComponent.prototype, "leftCounter", {
        get: function () {
            return isNil(this.maxLength) ? null : this.maxLength - (isNil(this.value) ? 0 : this.value.length);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HlcClrTextComponent.prototype, "counterStyle", {
        get: function () {
            if (isNil(this.leftCounter)) {
                return null;
            }
            else if (this.leftCounter < 0) {
                return 'text-counter-danger';
            }
            else if (!isNil(this.warningLimit) &&
                !isNil(this.maxLength) &&
                this.warningLimit > this.leftCounter) {
                return 'text-counter-warning';
            }
        },
        enumerable: true,
        configurable: true
    });
    var HlcClrTextComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrTextComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrTextComponent.prototype, "id", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTextComponent.prototype, "placeholder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTextComponent.prototype, "readonly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTextComponent.prototype, "maxLength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrTextComponent.prototype, "warningLimit", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrTextComponent.prototype, "valueChange", void 0);
    HlcClrTextComponent = HlcClrTextComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-text',
            template: "<div class=\"clr-input-wrapper\">\r\n    <input\r\n        class=\"clr-input\"\r\n        [placeholder]=\"placeholder || ''\"\r\n        [readonly]=\"readonly ? true : undefined\"\r\n        [value]=\"cleanValue\"\r\n        (keyup)=\"onChange($event)\"\r\n        type=\"text\"\r\n    />\r\n    <span *ngIf=\"maxLength\" class=\"text-counter\" [ngClass]=\"counterStyle\">\r\n        <span>{{ maxLength - leftCounter }}</span> / <span>{{maxLength}}</span>\r\n    </span>\r\n</div>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrTextComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrTextComponent);
    return HlcClrTextComponent;
}());

var HlcClrTextModule = /** @class */ (function () {
    function HlcClrTextModule() {
    }
    HlcClrTextModule = __decorate([
        NgModule({
            imports: [CommonModule, FormsModule, ClrInputModule],
            declarations: [HlcClrTextComponent],
            exports: [HlcClrTextComponent]
        })
    ], HlcClrTextModule);
    return HlcClrTextModule;
}());

var HlcClrToggleComponent = /** @class */ (function () {
    function HlcClrToggleComponent() {
        this.valueChange = new EventEmitter();
        this.propagateChange = function (_) { };
        this.id = "toggle_" + HlcClrToggleComponent_1.togglesCount;
        HlcClrToggleComponent_1.togglesCount++;
    }
    HlcClrToggleComponent_1 = HlcClrToggleComponent;
    HlcClrToggleComponent.prototype.ngOnInit = function () { };
    HlcClrToggleComponent.prototype.onChange = function (val) {
        this.value = val;
        this.propagateChange(val);
        this.valueChange.emit(val);
    };
    //
    HlcClrToggleComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    HlcClrToggleComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HlcClrToggleComponent.prototype.registerOnTouched = function (_) { };
    var HlcClrToggleComponent_1;
    HlcClrToggleComponent.togglesCount = 0;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HlcClrToggleComponent.prototype, "text", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HlcClrToggleComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], HlcClrToggleComponent.prototype, "readonly", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], HlcClrToggleComponent.prototype, "valueChange", void 0);
    HlcClrToggleComponent = HlcClrToggleComponent_1 = __decorate([
        Component({
            selector: 'hlc-clr-toggle',
            template: "<div class=\"clr-toggle-wrapper\">\r\n    <input type=\"checkbox\" [checked]=\"value ? 'checked' : undefined\" (change)=\"onChange($event.target.checked)\" [attr.id]=\"id\" />\r\n    <label [attr.for]=\"id\">{{ text }}</label>\r\n</div>\r\n",
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return HlcClrToggleComponent_1; }),
                    multi: true
                }
            ],
            styles: [""]
        }),
        __metadata("design:paramtypes", [])
    ], HlcClrToggleComponent);
    return HlcClrToggleComponent;
}());

var HlcClrToggleModule = /** @class */ (function () {
    function HlcClrToggleModule() {
    }
    HlcClrToggleModule = __decorate([
        NgModule({
            imports: [CommonModule],
            declarations: [HlcClrToggleComponent],
            exports: [HlcClrToggleComponent]
        })
    ], HlcClrToggleModule);
    return HlcClrToggleModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { DATE_CONFIG, DATE_CONVERT_CONFIG, DateConvertService, DictMapperService, DictMapperSetterService, HLC_CLR_PHONE_CONFIG, HlcClrCheckboxesComponent, HlcClrCheckboxesModule, HlcClrDateComponent, HlcClrDateModule, HlcClrDateRangeComponent, HlcClrDateRangeModule, HlcClrDateTimeComponent, HlcClrDateTimeModule, HlcClrDisplayComponent, HlcClrDisplayModule, HlcClrMaskComponent, HlcClrMaskModule, HlcClrMonthYearSelectComponent, HlcClrMonthYearSelectModule, HlcClrMultiSelectComponent, HlcClrMultiSelectModule, HlcClrOptionsComponent, HlcClrOptionsModule, HlcClrPairsListComponent, HlcClrPairsListModule, HlcClrPasswordComponent, HlcClrPasswordModule, HlcClrPhoneComponent, HlcClrPhoneModule, HlcClrSelectComponent, HlcClrSelectModule, HlcClrTagsComponent, HlcClrTagsModule, HlcClrTextAreaComponent, HlcClrTextAreaModule, HlcClrTextComponent, HlcClrTextModule, HlcClrToggleComponent, HlcClrToggleModule, HlcClrTypeaheadComponent, HlcClrTypeaheadModule, MaskDirective, MaskPipe, MaskService, NgxMaskModule, RangeMapperService, TextMask, TypeaheadMapperService, TypeaheadStrMapperService, _configFactory, defaultPhoneConfig, monthYearRequiredValidator, ɵ0, ɵ1, MaskApplierService as ɵa, config as ɵc, NEW_CONFIG as ɵd, INITIAL_CONFIG as ɵe, initialConfig as ɵf, HlcClrTagsListModule as ɵg, HlcClrTagsListComponent as ɵh };
//# sourceMappingURL=ng-holistic-clr-controls.js.map
