import { EventEmitter, OnInit, QueryList } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { HlcClrDateComponent } from '../date/date.component';
import { RangeMapperService } from '../range.config';
export interface DateRangeValues {
    readonly?: boolean;
    format?: string;
}
export declare class HlcClrDateRangeComponent implements OnInit, ControlValueAccessor, DateRangeValues {
    private readonly rangeMapperService;
    value: any | undefined | null;
    format: string | undefined;
    readonly: boolean;
    dateComponents: QueryList<HlcClrDateComponent>;
    valueChange: EventEmitter<any>;
    propagateChange: (_: any) => void;
    constructor(rangeMapperService: RangeMapperService);
    ngOnInit(): void;
    get dateFrom(): any;
    get dateTo(): any;
    onDateFromChange(val: any): void;
    onDateToChange(val: any): void;
    onChange(): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(_: any): void;
}
