import { EventEmitter, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { DateConvertService } from '../date-convert.service';
import { DateConfig } from '../date.config';
import { DictMapperService } from '../list-items.config';
export interface DateTimeValues {
    readonly?: boolean;
}
export declare class HlcClrDateTimeComponent implements OnInit, OnInit, ControlValueAccessor, DateTimeValues {
    private readonly dateConvertService;
    private readonly dateConfig?;
    readonly hours: any[];
    readonly minutes: any[];
    value: string | undefined | null;
    format: string | undefined;
    readonly: boolean;
    valueChange: EventEmitter<string | null | undefined>;
    propagateChange: (_: any) => void;
    constructor(dateConvertService: DateConvertService, dateConfig?: DateConfig | undefined);
    get dictMapper(): DictMapperService;
    get date(): Date | undefined;
    set date(val: Date | undefined);
    get placeholder(): string | undefined;
    ngOnInit(): void;
    onChange(): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(_: any): void;
    get hour(): number | undefined;
    get minute(): number | undefined;
    onHourChange(hour: number): void;
    onMinuteChange(min: number): void;
    private formatToDomainStr;
}
