import { DatePipe } from '@angular/common';
import { EventEmitter, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export interface MonthYearSelectValue {
    month: number;
    year: number;
}
export declare class HlcClrMonthYearSelectComponent implements OnInit, ControlValueAccessor {
    private readonly datePipe;
    value: MonthYearSelectValue;
    yearFrom?: number;
    yearTo?: number;
    valueChange: EventEmitter<MonthYearSelectValue>;
    years: {
        key: number;
        label: string;
    }[];
    months: {
        key: number;
        label: string;
    }[];
    private static onYearChange;
    get yearValue(): number;
    get monthValue(): number;
    constructor(datePipe: DatePipe);
    ngOnInit(): void;
    onYearChange(year: number): void;
    onMonthChange(month: number): void;
    private onValueChanged;
    propagateChange: (_: any) => void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(_: any): void;
}
