import { EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { SearchArg } from '@ng-holistic/typeahead';
import * as R from 'ramda';
import { BehaviorSubject, Observable } from 'rxjs';
import { DictMapperService } from '../list-items.config';
import { HlcClrTypeaheadComponent, TypeaheadConfig } from '../typeahead/typeahead.component';
export declare class HlcClrTagsComponent implements ControlValueAccessor {
    private readonly dictMapper;
    value$: BehaviorSubject<any>;
    set value(val: any[]);
    get value(): any[];
    config: TypeaheadConfig | undefined;
    readonly: boolean | undefined;
    allowAddNew: boolean;
    placeholder: string | undefined;
    showSorted: boolean | ((item: any) => R.Ord);
    addNew: EventEmitter<string>;
    typeahead: HlcClrTypeaheadComponent;
    propagateChange: (_: any) => void;
    constructor(dictMapper: DictMapperService);
    private search;
    get _config(): {
        search: (args$: Observable<SearchArg>) => Observable<any[]>;
        mapper?: import("../..").TypeaheadMapper | undefined;
    } | undefined;
    onChange($event: any): void;
    onRemove(item: any): void;
    onAddNew(text: string): void;
    get sortedValue(): any[];
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(_: any): void;
    private filterItem;
    private filterItems;
}
