import { EventEmitter, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export interface TextValues {
    placeholder?: string;
    readonly?: boolean;
}
export declare class HlcClrTextComponent implements OnInit, ControlValueAccessor, TextValues {
    value: string;
    id: string;
    placeholder: string | undefined;
    readonly: boolean | undefined;
    maxLength: number | undefined;
    /**
     * Left characters from maxLength for applying waring style on displayed left chars text
     */
    warningLimit: number | undefined;
    valueChange: EventEmitter<string>;
    propagateChange: (_: any) => void;
    constructor();
    ngOnInit(): void;
    onChange($event: any): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(_: any): void;
    get cleanValue(): string;
    get leftCounter(): number | null;
    get counterStyle(): "text-counter-danger" | "text-counter-warning" | null | undefined;
}
