import { EventEmitter, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { SearchArg } from '@ng-holistic/typeahead';
import { Observable } from 'rxjs';
import { TypeaheadMapper, TypeaheadMapperService } from './typeahead-mapper.service';
export interface TypeaheadObjectMap {
    key: string;
    label: string;
    description: string;
}
export interface TypeaheadConfig {
    search: (text: Observable<SearchArg>) => Observable<any[]>;
    mapper?: TypeaheadMapper;
}
export declare class HlcClrTypeaheadComponent implements OnInit, ControlValueAccessor {
    private readonly mapper;
    value: any;
    config: TypeaheadConfig | undefined;
    readonly: boolean | undefined;
    placeholder: string;
    allowAddNew: boolean;
    valueChange: EventEmitter<any>;
    addNew: EventEmitter<any>;
    input: any;
    propagateChange: (_: any) => void;
    constructor(mapper: TypeaheadMapperService);
    ngOnInit(): void;
    getKey(obj: any): any;
    getLabel: (obj: any) => any;
    getDescription(obj: any): any;
    get search(): ((text: Observable<SearchArg>) => Observable<any[]>) | undefined;
    onChange($event: any): void;
    resetValue(): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(_: any): void;
}
